<template>
  <china-register v-if="selectedThemeName === 'china'" />
  <!-- <modern-register v-else-if="selectedThemeName === 'modern'" /> -->
  <div class="use-new-color-config" v-else>
  <div class="container mx-auto py-10 flex" :class="selectedThemeName === 'playful' && '!pb-4 !pt-2'">
    <div class="w-[1200px] flex-none m-auto bg-background5 rounded-2xl overflow-hidden">
      <div class="h-[64px] flex items-center justify-between py-0 pl-[40px] pr-[16px] bg-background5">
        <h1 class="text-left text-2xl font-semibold text-[var(--secondary)]">{{ $t('capital_login') }}</h1>
        <close-button />
      </div>
      <div class="w-full h-[2px] bg-border"></div>
      <el-col class="w-[400px] py-6 px-10 h-[654px] overflow-hidden bg-background5 login-form">
        <el-form
          ref="loginFormRef"
          :model="loginFormData"
          :rules="loginRules"
          :validate-on-rule-change="false"
          label-position="left"
        >
          <el-form-item :label="$t('username')" prop="Username">
            <el-input
              v-model="loginFormData.Username"
              :disabled="isLoginProccessing"
              type="text"
              id="loginUsername"
            />
          </el-form-item>
          <el-form-item :label="$t('password')" prop="Password">
            <el-input
              v-model="loginFormData.Password"
              :disabled="isLoginProccessing"
              type="password"
              id="loginPassword"
            />
          </el-form-item>
          <el-divider class="bg-border" />
          <div class="btn-click-captcha-to-verify">
            <el-form-item
            v-if="!clientCaptcha.IsHidden"
            prop="Captcha"
            :show-message="true"
            >
              <div id="captcha-button">
                <div id="captcha-pop-up-verify" class="w-full">
                  <template v-if="!captchaErrorMsg.length && loginFormData.Captcha.length == 5 && !isDialogVisible">
                    <div class="relative w-[18px] h-[18px]">
                      <img :src="getAssetImage('assets/theme/light_flexible_1/desktop/images/menu/captcha-success.png')"
                        alt="verify icon success" loading="lazy">
                    </div>
                    <span class="whitespace-nowrap">{{ $t('successful_verification') }}</span>
                  </template>
                  <template v-else>
                    <div class="flex justify-center items-center gap-1 w-full" @click="isDialogVisible = true">
                      <div class="relative w-[18px] h-[18px]">
                        <img :src="getAssetImage('assets/theme/light_flexible_1/desktop/images/menu/capcha.png')"
                          alt="verify icon" loading="lazy">
                      </div>
                      <span>{{ $t('click_to_verify') }}</span>
                    </div>
                  </template>
                </div>
              </div>
            </el-form-item>
          </div>
          <div class="mt-5 text-center">
            <el-button v-on:click="submitLogin(loginFormRef)" :disabled="isLoginProccessing" class="px-4 py-1 text-sm w-full rounded btn bg-secondary" id="loginSubmitBtn"><b>{{ $t('capital_login') }}</b></el-button>
          </div>
          <el-form-item class="forgot-password-form-item" :class="themeColor ? themeColor.Text : ''">
            <auth-forgot-password-modal />
          </el-form-item>
          <!-- Resister -->
          <div v-if="!register.IsHidden">
            <div class="text-center text-xs fc-text4">
              {{ $t("dont_have_an_account?") }}
              <nuxt-link
                class="text-primary underline cursor-pointer"
                to="/register"
                :id="ID.SIGNUP"
              >
                {{ $t("joinnow") }}
              </nuxt-link>
            </div>
          </div>
          <theme-common-telegram-login-button
            :is-show="isTelegramBotSetup"
            :username="telegramBotUsername"
            @callback="telegramCallbackFunction"
          />
        </el-form>
      </el-col>
      <el-col class="relative register-info w-[800px] h-[654px] flex justify-center flex-col items-center text-center ol-bg-light">
        <div class="text-center">
          <div class="w-[752px] h-[504px]">
            <img :src="loginRegister.ImagePath" class="w-full h-full object-contain" />
          </div>
          <div class="text-primary text-2xl font-black mb-1">
            <span>{{ $t('welcome_to') }}</span>
            <template v-if="allowCompany">
              <span class="font-black text-[32px] fc-text4 ml-1">{{ seoTitle.Text }}</span>
            </template>
            <template v-else>
              <span v-if="!companyName.IsHidden" class="font-black text-[32px] fc-text4 ml-1">{{ companyName.Text }}</span>
            </template>
          </div>
          <div class="text-base fc-text4">{{ $t(loginRegister.Text) }}</div>
        </div>
      </el-col>
    </div>
  </div>
  <div class="captcha-dialog-container">
    <el-dialog
      align-center
      destroy-on-close
      :show-close="false"
      custom-class="p-[15px] captcha-dialog"
      v-model="isDialogVisible"
      width="320px"
      @open="loginFormData.Captcha = ''"
      @close="loginFormRef?.validateField('Captcha')"
      >
      <utils-client-captcha v-if="!clientCaptcha.IsHidden" v-model:captcha="loginFormData.Captcha"
        v-model:dialogVisible="isDialogVisible" :get-error-message="getCaptchaErrorMsg"
        :is-invalid="captchaErrorMsg.length > 0" />
    </el-dialog>
  </div>
  </div>
</template>

<script lang="ts">
import {
  computed,
  defineComponent, ref,
} from 'vue';
import useLogin from '@/composables/useLogin';
import { clientCaptcha } from '@/composables/captcha/useCaptcha';
import { IThemePropertiesFromApi } from '@/models/companyThemePropertiesRespone';
import { store } from '@/store';

export default defineComponent({
  name: 'Login',
  setup() {
    const themeProperties = computed(() => store.state.companyThemePropertiesFromApi.ThemeProperties);
    const themeColor = computed((): IThemePropertiesFromApi => themePropertyHelper.getSingleThemeProperty(themeProperties.value, 'theme_color'));
    const {
      loginFormRef,
      loginFormData,
      loginRules,
      submitLogin,
      isLoginProccessing,
      captchaErrorMsg,
      getCaptchaErrorMsg,
      register,
      isTelegramBotSetup,
      telegramBotUsername,
      checkLoginTelegramSetup,
      telegramCallbackFunction,
    } = useLogin();
    const { getAssetImage, allowCompany } = commonHelper;
    const selectedThemeName = store.state.selectedThemeName;
    const isDialogVisible = ref(false);
    checkLoginTelegramSetup();
    const loginRegister = computed(
    (): IThemePropertiesFromApi =>
      themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "login_register"
      )
    );
    const companyName = computed(
    (): IThemePropertiesFromApi =>
      themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "login_register_company_name"
      )
    );
    const seoTitle = computed(
    (): IThemePropertiesFromApi =>
      themePropertyHelper.getSingleThemeProperty(
        themeProperties.value,
        "seo_title"
      )
    );
    return {
      getAssetImage,
      companyName,
      themeColor,
      loginFormRef,
      loginFormData,
      loginRules,
      submitLogin,
      isLoginProccessing,
      clientCaptcha,
      captchaErrorMsg,
      getCaptchaErrorMsg,
      isDialogVisible,
      loginRegister,
      selectedThemeName,
      register,
      telegramCallbackFunction,
      isTelegramBotSetup,
      telegramBotUsername,
      seoTitle,
      allowCompany,
    };
  },
});
</script>
<style scoped>
.register-info,
.login-form {
  --bg-base-color: var(--background5);
  --bg-opacity: 5%;
}
:deep(.forgot-password-form-item.main_orange .forgot-password-entry-link) {
  color: var(--primary);
}
.login{
  display: block;
}
.el-form-item {
  display: block;
  margin-bottom: 16px;
}
.text-primary {
  color: var(--primary);
}
.el-button.is-round {
  border-radius: 4px;
}
:deep(.forgot-password-form-item .el-form-item__content) {
  margin: 0;
  justify-content: center;
  line-height: 0;
  margin-top: 20px;
}
:deep(.el-form-item__label) {
  color: var(--text5);
}
.bg-border {
  background: var(--border);
  border-top: 1px var(--el-border-style) var(--border) !important;
}
.el-divider--horizontal{
  margin: 24px 0;
}
.el-input .el-input__inner {
  color: var(--text5);
  background: linear-gradient(
      0deg,
      rgba(var(--bg-light-overlay), var(--bg-opacity)),
      rgba(var(--bg-light-overlay), var(--bg-opacity))
    ),
    linear-gradient(0deg, var(--bg-base-color), var(--bg-base-color)) !important;
}
</style>
